using System.Security.Claims;
using Domain.Entities.Forum.ValueObject;
using Application.Abstractions.Messaging;
using Web.Api.Common;
using Web.Api.Extensions;

namespace Web.Api.Endpoints.Forum.Post;

internal sealed class ToggleReaction : IEndpoint
{
    public sealed record Request(Reaction Reaction);

    public void MapEndpoint(IEndpointRouteBuilder app)
    {
        app.MapPost("api/forum/posts/{id}/reaction", async (
            int id,
            ClaimsPrincipal user,
            Request request,
            ISender sender,
            CancellationToken ct
        ) => {
            var memberID = user.GetMemberID();

            if (memberID is null)
            {
                return ApiResponse.Fail(StatusCodes.Status401Unauthorized, "Invalid token");
            }

            var command = new Application.Features.Api.Forum.PostReaction.Toggle.Command(
                memberID.Value,
                id,
                request.Reaction
            );

            var result = await sender.Send(command, ct);

            return result.Match(
                () => ApiResponse.Ok(),
                CustomResults.Problem
            );
        })
        .WithTags("Forum")
        .RequireAuthorization();
    }
}
